This file contains the code for the subroutines in
Perl-speaks-NONMEMs data module. It is not functional by itself.
The code should be transferred to the module autogenerated by dia2code
using the fill_diacode.pl script.

# {{{ include

start include statements
use Digest::MD5 'md5_hex';
use OSspecific;
use File::Copy "cp";
use Carp;
use Carp qw(cluck);
use Config;
use Math::Random;
use Storable;
use debug;
use ui;
use status_bar;
use Data::Dumper;
use Time::HiRes qw(gettimeofday);
my @primary_column_names = ('ID', 'DATE', 'DAT1', 'DAT2', 'DAT3' ,'L1', 'L2', 'DV', 'MDV', 'RAW_', 'MRG_', 'RPT_', 'TIME', 'DROP', 'SKIP', 'EVID', 'AMT', 'RATE', 'SS', 'II', 'ADDL', 'CMT', 'PCMT', 'CALL');
end include

# }}} include statements

# {{{ description

start description
    # The structure of the data class is subject-centric, recognising that
    # the subjects included in a study often can be regarded as
    # independent. A class for the subject level exists within PsN and is
    # called the individual class. A data object consists of at least one
    # but probably many individual objects plus optional comments.
end description

# }}} description

# {{{ synopsis

start synopsis
    #   use data;
    #
    #   my $data_obj = data -> new ( filename => 'test040314.dta' );
    #
    #   $data_obj -> renumber_ascending;
    #
    #   my $subsets_ref = $data_obj -> case_deletion( bins => 10 );
    #
    #   my @subsets = @{$subsets_ref};
end synopsis

# }}} synopsis

# {{{ see_also

start see_also
    # =begin html
    #
    # <a HREF="model.html">model</a>, <a HREF="output.html">output</a>,
    # <a HREF="tool/modelfit.html">tool::modelfit</a>,
    # <a HREF="tool.html">tool</a>
    #
    # =end html
    #
    # =begin man
    #
    # model, output, tool::modelfit, tool
    #
    # =end man
end see_also

# }}} see_also

# {{{ new

start new
      {
	# If the column holding the subject identifier is not the
	# first, it can be specified using the I<idcolumn> attribute
	#
	# I<ignoresign> determines which rows that are regarded as
	# comments. Corresponds to the IGNORE= option in the $DATA
	# record in a NONMEM model file.

	$this -> {'use_data_table'} = 0;

	( $this -> {'directory'},
	  $this -> {'filename'} ) = OSspecific::absolute_path( $this -> {'directory'},
							       $this->{'filename'} );

	debug -> warn( level => 2, 
		       message => "data -> new: Data object initialized from file: ".
		       $this -> full_name );

# 	sub register_in_database {
# 	  my $this = shift;
# 	  # Backslashes messes up the sql syntax
# 	  my $file_str = $this->{'filename'};
# 	  my $dir_str = $this->{'directory'};
# 	  $file_str =~ s/\\/\//g;
# 	  $dir_str =~ s/\\/\//g;

# 	  # md5sum
# 	  my $md5sum = md5_hex(OSspecific::slurp_file($this-> full_name ));
# 	  my $dbh = DBI ->
# 	      connect("DBI:mysql:host=".$PsN::config -> {'_'} -> {'database_server'}.
# 		      ";databse=".$PsN::config -> {'_'} -> {'project'},
# 		      $PsN::config -> {'_'} -> {'user'},
# 		      $PsN::config -> {'_'} -> {'password'},
# 		      {'RaiseError' => 1});
# 	  my $sth;
# 	  my $sth = $dbh -> prepare( "SELECT data_id FROM ".$PsN::config -> {'_'} -> {'project'}.
# 			       ".data ".
# 				     "WHERE filename = '$file_str' AND ".
# 				     "directory = '$dir_str' AND ".
# 				     "md5sum = '".$md5sum."'" );
# 	  $sth -> execute or debug -> die( message => $sth->errstr ) ;
# 	  my $select_arr = $sth -> fetchall_arrayref;
# 	  if ( scalar @{$select_arr} > 0 ) {
# 	    debug -> warn( level   => 1,
# 			   message => "Found an old entry in the database matching the ".
# 			   "current data file" );
# 	    if ( scalar @{$select_arr} > 1 ) {
# 	      debug -> warn( level   => 1,
# 			     message => "Found more than one matching entry in database".
# 			     ", using the first" );
# 	    }
# 	    $this -> {'data_id'} = $select_arr->[0][0];
# 	  } else {
# 	    my ( $date_str, $time_str );
# 	    if ( $Config{osname} eq 'MSWin32' ) {
# 	      $date_str = `date /T`;
# 	      $time_str = ' '.`time /T`;
# 	    } else {
# 	      # Assuming UNIX
# 	      $date_str = `date`;
# 	    }
# 	    chomp($date_str);
# 	    chomp($time_str);
# 	    my $date_time = $date_str.$time_str;
# 	    $sth = $dbh -> prepare("INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
# 			       ".data (filename,date,directory,md5sum) ".
# 				   "VALUES ('$file_str', '$date_time', '$dir_str','".
# 				   $md5sum."' )");
# 	    $sth -> execute;
# 	    $this -> {'data_id'} = $sth->{'mysql_insertid'};
# 	  }
# 	  $sth -> finish;
# 	  $dbh -> disconnect;
#         }


	unless ( ( defined $this -> {'header'} and 
		   scalar @{$this -> {'header'}} > 0 ) or
		 ( defined $this -> {'individuals'} and 
		   scalar @{$this -> {'individuals'}} > 0 ) ) { 
	  if ( -e $this -> full_name ) {
	    if ( $this -> {'target'} eq 'mem' ) {
#	      &register_in_database( $this ) if ( $PsN::config -> {'_'} -> {'use_database'} and
#						  $this -> {'use_data_table'} );
	      $this -> _read_header;
	      $this -> _read_individuals;
	      $this -> {'synced'} = 1;
	    } else {
	      $this -> {'synced'} = 0;
	    }
	  } else {
	    debug -> die(message => "No header, individuals, and no file " . $this -> full_name . " on disk.")
	      unless $this -> {'ignore_missing_files'};
	    $this ->  {'synced'} = 0;
	  }
	} else {
	  if ( $this -> {'target'} eq 'mem') {
	    if ( -e $this -> {'filename'} ) {
	      $this -> _read_header;
#	      &register_in_database if ( $PsN::config -> {'_'} -> {'use_database'} and
#					 $this -> {'use_data_table'} );
	      $this -> _read_individuals;
	      $this -> {'synced'} = 1;
	    } else {
	      debug -> die(message => "No file:".$this->{'filename'}." on disk" )
		  unless $this -> {'ignore_missing_files'};
	      $this -> {'synced'} = 0;
	    }
	  } else { 
	    $this -> flush;
	  }
	}

	if ( $this -> {'synced'} ) {
	  my $i = 1;
	  foreach my $head ( @{$this -> {'header'}} ) {
	    $this -> {'column_head_indices'} -> {$head} = $i;
	    $i++;
	  }
	}
#	$Data::Dumper::Maxdepth = 3;
#	die Dumper $this -> {'individuals'};
      }
end new

# }}} new

# {{{ register_in_database
start register_in_database
    if ( $PsN::config -> {'_'} -> {'use_database'} ) {
      # Backslashes messes up the sql syntax
      my $file_str = $self->{'filename'};
      my $dir_str = $self->{'directory'};
      $file_str =~ s/\\/\//g;
      $dir_str =~ s/\\/\//g;

      my $project = $PsN::config -> {'_'} -> {'project'};
      # md5sum
      my $md5sum = md5_hex(OSspecific::slurp_file($self-> full_name ));

      my $dbh = DBI -> connect("DBI:mysql:host=".$PsN::config -> {'_'} -> {'database_server'}.
			       ";databse=".$project,
			       $PsN::config -> {'_'} -> {'user'},
			       $PsN::config -> {'_'} -> {'password'},
			       {'RaiseError' => 1});

      my $sth;

      my $select_arr = [];

      if ( not $force ) {
	my $sth = $dbh -> prepare( "SELECT data_id FROM ".$project.
				   ".data ".
				   "WHERE filename = '$file_str' AND ".
				   "directory = '$dir_str' AND ".
				   "md5sum = '".$md5sum."'" );
	$sth -> execute or debug -> die( message => $sth->errstr ) ;
	$select_arr = $sth -> fetchall_arrayref;
      }

      if ( scalar @{$select_arr} > 0 ) {
	'debug' -> warn( level   => 1,
			 message => "Found an old entry in the database matching the ".
			 "current data file" );
	if ( scalar @{$select_arr} > 1 ) {
	  'debug' -> warn( level   => 1,
			   message => "Found more than one data matching entry in database".
			   ", using the first" );
	}
	$self -> {'data_id'} = $select_arr->[0][0];
	# Find the id's
	my $sth = $dbh -> prepare( "SELECT individual_id FROM ".$project.".data_individual ".
				   "WHERE data_id = '".$self -> {'data_id'}."'" );
	$sth -> execute or debug -> die( message => $sth->errstr ) ;
	my $id_arr = $sth -> fetchall_arrayref;
	map( $_ = $_ -> [0], @{$id_arr} );
	$self -> {'individual_ids'} = $id_arr;
      } elsif ( defined $self -> {'individuals'} ) {
	my ( $date_str, $time_str );
	if( $Config{osname} eq 'MSWin32' ){
	  $date_str = `date /T`;
	  $time_str = ' '.`time /T`;
	} else {
	  # Assuming UNIX
	  $date_str = `date`;
	}
	chomp($date_str);
	chomp($time_str);
	my $date_time = $date_str.$time_str;
	my ( $columns, $values );
	my $res_str = $resampled ? '1' : '0';
	if ( defined $model_id ) {
	  $columns = '(model_id, filename, date, directory, md5sum, resampled)';
	  $values = "('$model_id', '$file_str', '$date_time', '$dir_str','".
	      $md5sum."', '$res_str' )";
	} else {
	  $columns = '(filename, date, directory, md5sum, resampled)';
	  $values = "('$file_str', '$date_time', '$dir_str','".$md5sum."', '$res_str' )";
	}
	$sth = $dbh -> prepare("INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
			       ".data $columns VALUES $values");
	$sth -> execute;
	$self -> {'data_id'} = $sth->{'mysql_insertid'};

	if ( defined $self -> {'data_id'} ) {
	  my $values;
	  my $columns = "( id_key, id )";
	  if( $#individual_ids >= 0 ) {
	    $self -> register_di_relation( individual_ids => \@individual_ids );
	  } else {
	    my $inds = scalar @{$self -> {'individuals'}};
	    $dbh -> do( "LOCK TABLES ".$PsN::config -> {'_'} -> {'project'}.
			".individual WRITE" );
#	    $sth = $dbh -> prepare( "SELECT MAX(individual_id)".
#				    " FROM ".$PsN::config -> {'_'} -> {'project'}.
#				    ".individual" );
	    $dbh -> do( 'USE '.$PsN::config -> {'_'} -> {'project'} );
	    $sth = $dbh -> prepare( "SHOW TABLE STATUS LIKE 'individual'" );
	    $sth -> execute or debug -> die( message => $sth->errstr ) ;
	    my $select_arr = $sth -> fetchall_arrayref;
	    my $first_id_id = $select_arr -> [0][10] ?
		$select_arr -> [0][10] : 0;
#	    my $first_id_id = $select_arr -> [0][0] ? ($select_arr -> [0][0] + 1) : 0;
	    my $last_id_id = $first_id_id + $inds - 1;
	    for( my $i = 0; $i < $inds; $i++ ) { 
	      if( defined $self -> {'individuals'}[$i] ) {
		my $id_id = $self -> {'individuals'}[$i] -> idnumber;
		$values = $values."," if ( defined $values );
		$values = $values."( $i, $id_id )";
	      }
	    }
	    $sth = $dbh -> prepare( "INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
				    ".individual $columns VALUES $values" );
	    $sth -> execute;
	    $dbh -> do( "UNLOCK TABLES" );
	    @individual_ids = ($first_id_id .. $last_id_id);
	    $self -> register_di_relation( individual_ids => \@individual_ids );
	  }
	  $self -> {'individual_ids'} = \@individual_ids;
	}
	$sth -> finish;
	$dbh -> disconnect;
      }
      $data_id = $self -> {'data_id'}; # return the data_id
    }
end register_in_database
# }}} register_in_database

# {{{ register_di_relation
start register_di_relation
  if ( $PsN::config -> {'_'} -> {'use_database'} and
       defined $self -> {'data_id'} and $#individual_ids >= 0 ) {
    my $dbh = DBI -> connect("DBI:mysql:host=".$PsN::config -> {'_'} -> {'database_server'}.
			     ";databse=".$PsN::config -> {'_'} -> {'project'},
			     $PsN::config -> {'_'} -> {'user'},
			     $PsN::config -> {'_'} -> {'password'},
			     {'raiseerror' => 1});
    my $sth;
    my $values;
    my $columns = "( data_id, individual_id )";
    foreach my $individual_id ( @individual_ids ) {
      if ( defined $individual_id ) {
	$values = $values."," if ( defined $values );
	$values = $values."(".$self -> {'data_id'}.", $individual_id )";
      }
    }
    $sth = $dbh -> prepare( "INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
			       ".data_individual $columns VALUES $values" );
    $sth -> execute;
    $sth -> finish if ( defined $sth );
    $dbh -> disconnect;
  }
end register_di_relation
# }}} register_di_relation

# {{{ full_name

start full_name
      {
	$full_name = $self -> {'directory'} . $self -> {'filename'};
      }
end full_name

# }}}

# {{{ bootstrap

start bootstrap
      {
	# The bootstrap method draws I<samples> number of boostrap
	# samples from the data set. The I<subjects> arguments
	# determines the size of each sample (default equals to the
	# number of individuals in the original data set). The method
	# returns references to three arrays: I<boot_samples_ref>,
	# which holds the bootstrap data sets, I<incl_individuals_ref>
	# which holds arrays containing the subject identifiers (ID's)
	# for the included individuals of each bootstrap data set and
	# I<included_keys_ref> which holds the key or index of the
	# included individuals. The key or index is an integer
	# starting at 1 for the first individual in the original data
	# set and increasing by one for each following.
	$self -> synchronize;
	my @header      = @{$self -> {'header'}};
	my $individuals = $self -> {'individuals'};
	my $key_ref;

	my $status_bar = status_bar -> new( steps => $samples );
	ui -> print( category => 'bootstrap',
		     message => $status_bar -> print_step,
		     newline => 0);

	for ( my $i = 1; $i <= $samples; $i++ ) {
	  my $new_name = defined $name_stub ? $name_stub."_$i.dta" : "bs$i.dta";
	  $new_name = $directory.'/'.$new_name;
	  my ( $boot, $incl_ind_ref, $incl_key_ref ) =
	    $self -> resample( subjects    => \%subjects,
			       resume      => $resume,
			       new_name    => $new_name,
			       target      => $target,
			       stratify_on => $stratify_on,
			       model_id    => $model_ids[$i-1] );
	  push( @included_keys, $incl_key_ref );
	  push( @incl_individuals, $incl_ind_ref );
# 	  $boot -> renumber_ascending;
	  push( @boot_samples, $boot );
#          $boot -> synchronize;
#          $boot -> flush;
	  if( $status_bar -> tick() ){
	    ui -> print( category => 'bootstrap',
			 message => $status_bar -> print_step,
			 newline => 0,
			 wrap => 0);
	  }
#	  print Dumper \@boot_samples;
#	  sleep(10);
	}
	ui -> print( category => 'bootstrap',
		     message => ' ... done' );
      }
end bootstrap

# }}} bootstrap

# {{{ resample

start resample
      {
	$self -> synchronize;
	my ( @header, $individuals, @bs_inds, $key_ref, @id_ids, @bs_id_ids );
	@id_ids = @{$self -> {'individual_ids'}} if( defined $self -> {'individual_ids'} );
	my @subj_keys = keys( %subjects );
	if ( $#subj_keys < 0 ) {
	  debug -> die( message => "sample_size must be defined" );
	}
	if ( defined $stratify_on ) {
	  my %strata;
	  if( $stratify_on =~ /\D/ ){
	    %strata = %{$self -> factors( column_head => $stratify_on )};
	    if ( $strata{'Non-unique values found'} eq '1' ) {
	      debug -> die( message => "Individuals were found to have multiple values in the $stratify_on column. ".
			    "The column $stratify_on cannot be used for stratification of the resampling." );
	    }
	  } else {
	    %strata = %{$self -> factors( column => $stratify_on )};
	    if ( $strata{'Non-unique values found'} eq '1' ) {
	      debug -> die( message => "Individuals were found to have multiple values in column number $stratify_on. ".
			    "Column $stratify_on cannot be used for stratification of the resampling." );
	    }
	  }
	  if ( scalar keys( %subjects) != scalar keys( %strata ) and
	       not ( $#subj_keys == 0 and defined $subjects{'default'} ) ) {
	    debug -> die( message => "sample_size must be defined using one default value ".
			  "or exactly one value per strata:\n".
			  "resampling per STUD=1001,1002,1003\n".
			  "use -sample_size='1001=>10,1002=>25,1003=>12' or ".
			  "-sample_size='default=>10'");
	  }
 	  unless ( $resume and -e $new_name ) {
 	    @header = @{$self -> {'header'}};
 	    $individuals = $self -> {'individuals'};
	    while( my ( $factor, $key_list ) = each %strata ) {
	      my $keys;
	      if ( defined $subjects{$factor} ) {
		$keys = $subjects{$factor};
	      } elsif( defined $subjects{'default'} ) {
		$keys = sprintf( "%.0f",($subjects{'default'}*
			       (scalar(@{$key_list}))/($self -> count_ind())) );
	      } else {
		debug -> die( message => "A sample size for strata $factor could not be found ".
			      "and no default sample size was set" );
	      }
	      for ( my $i = 0; $i < $keys; $i++ ) {
		my $list_ref = random_uniform_integer(1,0,(scalar(@{$key_list}) - 1));
		push( @bs_inds, $individuals ->
		      [ $key_list -> [$list_ref] ] -> copy );
		push( @included_keys, $key_list -> [$list_ref] );
		push( @incl_individuals, $individuals ->
		      [ $key_list -> [$list_ref] ] -> idnumber );
		push( @bs_id_ids, $id_ids[ $key_list -> [$list_ref] ] );
	      }
	    }

	    $boot = data -> new( header      => \@header,
				 idcolumn    => $self -> {'idcolumn'},
				 ignoresign  => $self -> {'ignoresign'},
				 individuals => \@bs_inds,
				 filename    => $new_name,
				 ignore_missing_files => 1,
				 target      => 'mem' );
	    $boot -> renumber_ascending;
	    $boot -> _write;
	    $boot -> flush;
	    #$boot -> target( $target );
 	  } else {
	    # If we are resuming, we still need to generate the
	    # pseudo-random sequence and initiate a data object
	    while( my ( $factor, $key_list ) = each %strata ) {
	      my $keys;
	      if ( defined $subjects{$factor} ) {
		$keys = $subjects{$factor};
	      } elsif( defined $subjects{'default'} ) {
		$keys = sprintf( "%.0f",($subjects{'default'}*
			       (scalar(@{$key_list}))/($self -> count_ind())) );
	      } else {
		debug -> die( message => "A sample size for strata $factor could not be found ".
			      "and no default sample size was set" );
	      }
	      for ( my $i = 0; $i < $keys; $i++ ) {
		my $list_ref = random_uniform_integer(1,0,(scalar(@{$key_list}) - 1));
	      }
	    }
	    $boot = data -> new( idcolumn    => $self -> {'idcolumn'},
				 ignoresign  => $self -> {'ignoresign'},
				 filename    => $new_name,
				 ignore_missing_files => 1,
				 target      => $target );

	    $boot -> _write;
	    $boot -> flush;
	  }
	} else {
	  my $size;
	  if( defined $subjects{'default'} ) {
	    $size = $subjects{'default'};
	  } else {
	    debug -> die( message => "No default sample size was set" );
	  }
	  unless ( $resume and -e $new_name ) {
 	    @header = @{$self -> {'header'}};
 	    $individuals = $self -> {'individuals'};
	    for ( my $i = 1; $i <= $size; $i++ ) {
	      $key_ref = random_uniform_integer(1,0,scalar @{$individuals}-1);
	      push( @bs_inds, $individuals -> [ $key_ref ] -> copy );
	      push( @included_keys, $key_ref );
	      push( @incl_individuals, $individuals -> [ $key_ref ] -> idnumber );
	      push( @bs_id_ids, $id_ids[ $key_ref ] );
	    }

	    # MUST FIX: If a file already exists with the same name,
	    # the created bs data set will be appended to this. IT
	    # MUST BE OVERWRITTEN!
	    $boot = data -> new( header      => \@header,
				 idcolumn    => $self -> {'idcolumn'},
				 ignoresign  => $self -> {'ignoresign'},
				 individuals => \@bs_inds,
				 filename    => $new_name,
				 ignore_missing_files => 1,
				 target      => 'mem' );
	    $boot -> renumber_ascending;
	    $boot -> _write;
	    $boot -> target( $target );
	  } else {
	    # If we are resuming, we still need to generate the
	    # pseudo-random sequence and initiate a data object
	    for ( my $i = 1; $i <= $size; $i++ ) {
	      random_uniform_integer(1,0,scalar @{$individuals}-1)
	    }
	    $boot = data -> new( idcolumn    => $self -> {'idcolumn'},
				 ignoresign  => $self -> {'ignoresign'},
				 filename    => $new_name,
				 ignore_missing_files => 1,
				 target      => $target );

	    $boot -> _write;
	    $boot -> flush;
	  }	
	  if( $target eq 'disk'){
	    $boot -> flush;
	  }
	}
	$boot -> register_in_database( individual_ids => \@bs_id_ids,
				       resampled      => 1,
				       model_id       => $model_id );
      }
end resample

# }}} resample

# {{{ case_deletion

start case_deletion
      {
	# case_deletion creates subsets of the data. The number of
	# subsets is specified by the bins argument. The individuals
	# of each subset is selected randomly or in ascending
	# numerical order depending on the selection argument that can
	# be either 'consecutive' or 'random'. case_column must be
	# specified to give the method something to base the selection
	# on. Valid case_column values are either the column number
	# (pure digits) or the name of the column in the (optional)
	# header row.
	$self -> synchronize;
	my @header    = @{$self -> {'header'}};
	if ( not defined $case_column ) {
	  debug -> die( message => "case_column must be specified" );
	} else {
	  if ( not $case_column =~ /^\d/ ) {
	    for ( my $i = 0; $i <= $#header; $i++ ) {
	      $case_column = $i+1 if ( $header[$i] eq $case_column );
	    }
	  }
	}
	$bins = defined $bins ? $bins :
	  scalar keys %{$self -> factors( column => $case_column)};
	my %factors   = %{$self -> factors( column => $case_column )};
	if ( $factors{'Non-unique values found'} eq '1' ) {
	  debug -> die( message => "Individuals were found to have multiple values in column number $case_column. ".
			"Column $case_column cannot be used for case deletion." );
	}

	my $maxbins   = scalar keys %factors;
	my @ftrs      = sort { $a <=> $b } keys %factors;
	my $individuals = $self -> {'individuals'};
	my $maxkey    = scalar @{$individuals} - 1;

	my ( @tmp_ftrs, @binsize ) =
	    ((),());
	my ( $k, $j, $i ) = ( 0, 0, 0 );
	# Create the binsizes
	for ( $j = 0; $j < $maxbins; $j++ ) {
	  $binsize[ $k++ ]++;
	  $k = 0 if( $k >= $bins );
	}
	$self -> _fisher_yates_shuffle( array => \@ftrs ) if( $selection eq 'random' );
	for ( $k = 0; $k < $bins; $k++ ) {
	  for ( $j = 0; $j < $binsize[ $k ]; $j++ ) {
#	    print "SK: ",$skipped_keys[ $k ]," F: ",$factors{ $ftrs[ $i ] },"\n";
            push( @{$skipped_keys[ $k ]}, @{$factors{ $ftrs[ $i ] }} );
            push( @{$skipped_values[ $k ]}, $ftrs[ $i++ ] );
	  }
	}

	for ( $k = 0; $k < $bins; $k++ ) {
	  my @cd_inds = ();
	  my @del_inds = ();
	SELKEYS: foreach my $key ( 0..$maxkey ) {
	  foreach my $skipped ( @{$skipped_keys[ $k ]} ) {
	    if ( $key == $skipped ) {
	      push( @{$skipped_ids[ $k ]}, $individuals ->
		    [ $skipped ] -> idnumber );
	      push( @del_inds, $individuals -> [ $key ] -> copy );
	      next SELKEYS;
	    }
	  }
	  push( @cd_inds, $individuals -> [ $key ] -> copy );
	}
	  # Set ignore_missing_files = 1 to make it possible to get the result
	  # in memory only
	  my $newdata = data ->
	      new ( header      => \@header,
		    ignoresign  => $self -> {'ignoresign'},
		    idcolumn    => $self -> {'idcolumn'},
		    individuals => \@cd_inds,
		    target      => $target,
		    filename    => $directory.'/cdd_'.($k+1).'.dta',
		    ignore_missing_files => 1 );
	  my $deldata = data ->
	      new ( header      => \@header,
		    ignoresign  => $self -> {'ignoresign'},
		    idcolumn    => $self -> {'idcolumn'},
		    individuals => \@del_inds,
		    target      => $target,
		    filename    => $directory.'/rem_'.($k+1).'.dta',
		    ignore_missing_files => 1 );
	  push( @subsets, $newdata );
	  push( @remainders, $deldata );
	  $newdata -> _write;
	  $newdata -> flush;
	  $deldata -> _write;
	  $deldata -> flush;
	}
      }
end case_deletion

# }}} case_deletion

# {{{ copy
start copy
      {
	# filename: new data file name.
	# 
	# target: keep the copy in memory ('mem') or write it to disk and flush the memory ('disk').

	($directory, $filename) = OSspecific::absolute_path( $directory, $filename );

	# Clone self into new data object. Why don't the individuals get cloned too?
	# strange. need to set synced to 0 AND set the {'individuals'} to undef.
	cp($self -> full_name, $directory.$filename );
	$new_data = Storable::dclone( $self );
	$new_data -> {'synced'} = 0;
	$new_data -> {'individuals'} = undef;
	$new_data -> synchronize;

	# Set the new file name for the copy
	$new_data -> directory( $directory );
	$new_data -> filename( $filename );
      }
end copy

# }}} copy

# {{{ column_to_array

start column_to_array
{
  $self -> synchronize;

  if ( not $column =~ /^\d/ ) {
    $column = $self -> {'column_head_indices'} -> {$column} - 1;
  }
  
  if( $column < 0 or $column > $#{$self -> {'header'}} ){
    return [];
  }

  #have separate loops for case without filter and with filter,
  #to minimize risk of errors.

  if (scalar(@filter)==0){
      foreach my $individual ( @{$self -> individuals} ){
	  foreach my $individual_row( @{$individual -> subject_data} ){
	      my @row = split(/,/ , $individual_row);
	      push( @array, $row[$column] );
	  }
      }  
  } else {
      my $index=0;
      foreach my $individual ( @{$self -> individuals} ){
	  foreach my $individual_row( @{$individual -> subject_data} ){
	      if ($filter[$index] > 0){
		  my @row = split(/,/ , $individual_row);
		  push( @array, $row[$column] );
	      }
	      $index++;
	      if ($index > $#filter){
		  $index=0;
	      }
	  }
      }
      unless ($index == 0){
	  'debug' -> die(message =>"Number of rows in dataset was not a multiple of ".
			 "filter length.");
      }
  }

}
end column_to_array

# }}}

# {{{ count_ind

start count_ind
      {
	# Returns the number of individuals in the data set.
	$self -> synchronize;
	if( defined $self -> individuals() ) {
	  $num = scalar @{$self -> individuals()};
	} else {
	  debug -> die( message => "No individuals found in file ".
			$self -> filename() );
	}
      }
end count_ind

# }}} count_ind

# {{{ diff

start diff
{
  $self -> synchronize;
  
  my $first_id = $self -> {'individuals'}[0];
  
  debug -> die( message => "No individuals defined in data object based on ".
		$self -> full_name ) unless ( defined $first_id );
  
  # Check if $column(-index) is defined and valid, else try to find index
  # using column_head

  my @data_row = split( /,/, $first_id -> subject_data -> [0] );
  if( $#columns >= 0 ) {
    foreach my $column ( @columns ) {
      unless ( defined $column && defined( $data_row[$column-1] ) ) {
	debug -> die( message => "Error in data -> factors: ".
		      "invalid column number: \"$column\"\n".
		      "Valid column numbers are 1 to ".
		      scalar @{$first_id -> subject_data ->[0]}."\n" );
      }
    }
  } elsif ( $#column_heads >= 0 ) {
    foreach my $column_head ( @column_heads ) {
      unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	debug -> die( message => "Error in data -> factors: unknown column: \"$column_head\" ".
		      "Valid column headers are (in no particular order):\n".
		      join(', ',keys(%{$self -> {'column_head_indices'}})) );
      } else {
	my $column = $self -> {'column_head_indices'}{$column_head};
	push( @columns, $column );
	debug -> warn( level   => 2,
		       message => "$column_head is in column number $column" );
      }
    }
  } else {
    debug -> die( message => "No column or column_head defined" );
  }

  if( $global_largest or $global_smallest or
      $largest_per_individual or $smallest_per_individual ) {
    if( not scalar @{$self -> {'individuals'}} == scalar @{$against_data -> individuals} ) {
      debug -> die( message => "Both data object must hold the same number of individuals ".
		    "and observations when calling data -> diff" );
    }
    for( my $i = 0; $i < scalar @{$self -> {'individuals'}}; $i++ ) {
      my %id_diffs = %{$self -> {'individuals'}[$i] ->
			   diff( against_individual => $against_data -> individuals -> [$i],
				 columns            => \@columns,
				 absolute_diff      => $absolute_diff,
				 diff_as_fraction   => $diff_as_fraction,
				 largest            => ( $global_largest or $largest_per_individual ),
				 smallest           => ( $global_smallest or $smallest_per_individual ) )};
      if( $global_largest ) {
	for( my $j = 0; $j <= $#columns; $j++ ) {
	  my $label = defined $column_heads[$j] ? $column_heads[$j] : $columns[$j];
	  if( not defined $diff_results{$label} or not defined $diff_results{$label}{'diff'} or
	      $id_diffs{$columns[$j]}{'diff'} > $diff_results{$label}{'diff'} ) {
	    $diff_results{$label}{'diff'} = $id_diffs{$columns[$j]}{'diff'};
	    $diff_results{$label}{'self'} = $id_diffs{$columns[$j]}{'self'};
	    $diff_results{$label}{'test'} = $id_diffs{$columns[$j]}{'test'};
	  }
	}
      }
    }
  } else {
    die "data -> diff is only implemented for finding the largest difference at any observation at this point\n";
  }
}
end diff

# }}} diff

# {{{ filename
start filename
      {
	if ( defined $parm and $parm ne $self -> {'filename'} ) {
	  $self -> {'filename'} = $parm;
	  $self -> {'data_id'} = undef;
#	  $self -> _write;
	}
      }
end filename
# }}} filename

# {{{ fractions

start fractions
      {
	my %factors = $self -> factors( 'return_occurences' => 1, 
					'unique_in_individual' => $unique_in_individual,
					'column_head' => $column_head,
					'column' => $column);
	
	my $sum = 0;
	while (my ($factor, $amount) = each %factors) {
	  if ( $factor == $self -> {'missing_data'} && $ignore_missing ) {
	    next;
	  } else {
	    $sum += $amount;
	  }
	}
	while (my ($factor, $amount) = each %factors) {
	  if ( $factor == $self -> {'missing_data'} && $ignore_missing ) {
	    next;
	  } else {
	    $fractions{$factor} = $amount/$sum;
	  }
	}
      }
end fractions

# }}} fractions

# {{{ factors

start factors
      {
	# Either column (number, starting at 1) or column_head must be specified.
	#
	# The default behaviour is to return a hash with the factors as keys
	# and as values references to arrays with the order numbers (not the ID numbers)
	# of the individuals that contain this factor
	#
	# If unique_in_individual is true (1), the returned hash will contain
	# an element with key 'Non-unique values found' and value 1 if any
	# individual contain more than one value in the specified column.
	#
	# Return occurences will calculate the occurence of each
	# factor value. Several occurences in one individual counts as
	# one occurence. The elements of the returned hash will have the factors
	# as keys and the number of occurences as values.
	#

	$self -> synchronize;

	# Check if $column(-index) is defined and valid, else try to find index
	# using column_head
	my $first_id = $self -> {'individuals'}[0];

	debug -> die( message => "No individuals defined in data object based on ".
		      $self -> full_name ) unless ( defined $first_id );

	my @data_row = split( /,/, $first_id -> subject_data -> [0] );
	unless ( defined $column && defined( $data_row[$column-1] ) ) {
	  unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	    debug -> die( message => "Error in data -> factors: unknown column: \"$column_head\" ".
			  "or invalid column number: \"$column\".\n".
			  "Valid column numbers are 1 to ".scalar @data_row ."\n".
			  "Valid column headers are (in no particular order):\n".
			  join(', ',keys(%{$self -> {'column_head_indices'}})) );
	  } else {
	    $column = $self -> {'column_head_indices'}{$column_head};
	    debug -> warn( level   => 2,
			   message => "$column_head is in column number $column" );
	  }
	}

	my $key = 0;
	foreach my $individual ( @{$self -> {'individuals'}} ) {
	  my @ifactors = keys %{$individual -> factors( column => $column )};
	  if ( scalar @ifactors > 1 and $unique_in_individual ) {
	    %factors = ( 'Non-unique values found' => 1 );
	    last;
	  }
	  debug -> die( message => "No value found in column $column in individual ".
			$individual -> idnumber ) if ( scalar @ifactors == 0 );

	  # Return occurences will calculate the occurence of each
	  # factor value. Several occurences in one individual counts as
	  # one occurence.

	  if ( $return_occurences ) {
	    foreach my $ifactor ( @ifactors ) {
	      $factors{$ifactor}++;
	    }
	  } else {
	    foreach my $ifactor ( @ifactors ) {
	      push( @{$factors{$ifactor}}, $key );
	    }
	  }
	  $key++;
	}
      }
end factors

# }}} factors

# {{{ find_individual

# start find_individual
#         foreach my $tmp_ind ( @{$self -> individuals} ) {
# 	  if ( $tmp_ind -> key == $key ) {
# 	    $individual = $tmp_ind;
# 	    last;
# 	  }
# 	}
#         if ( defined $individual ) {
# 	  if ( $copy ) {
# 	    $individual = $individual -> copy;
# 	  }
# 	} else {
# 	  print "No individual with key $key found in call to ".
# 	    "data -> find_individual\n" if ( $self -> debug );
#         }
# end find_individual

# }}}

# {{{ format_data

start format_data
      {
	my $header = $self -> {'header'};

	# format the data for NONMEM (simple comma-separated layout)
	if ( defined $self -> {'comment'} ) {
	  my @comment   = @{$self -> {'comment'}};
	  for ( @comment ) {
	    push( @form_data );
	  }
	}

	my $wrap = ( defined $self -> {'wrap_column'} and
		     defined $self -> {'cont_column'} );

	my @primary_columns = defined $self -> {'primary_columns'} ?
	  @{$self -> {'primary_columns'}} : ();
	my @secondary_columns = defined $self -> {'secondary_columns'} ?
	  @{$self -> {'secondary_columns'}} : ();
	if ( defined $header and defined $self -> {'ignoresign'} ) {
	  my $istr;
	  if ( $self -> {'ignoresign'} ne '@' ) {
	    $istr = $self -> {'ignoresign'};
	  }
	  if ( $wrap ) {
	    my @h_data;
	    for ( my $i = 0; $i <= $#secondary_columns ; $i++ ) {
	      my $sstr = $istr;
	      for ( my $j = 0; $j < scalar @{$secondary_columns[$i]} ; $j++ ) {
		my $jstr = $j == 0 ? '' : ',';
		$sstr = $sstr.$jstr.$secondary_columns[$i][$j][0];
	      }
	      push( @h_data, $sstr."\n" );
	    }
	    push( @form_data, @h_data );
	    my $pstr = $istr;
	    for ( my $i = 0; $i <= $#primary_columns ; $i++ ) {
	      my $jstr = $i == 0 ? '' : ',';
	      $pstr = $pstr.$jstr.$primary_columns[$i][0];
	    }
	    push( @form_data, $pstr."\n" );
	  } else {
	    push( @form_data, $istr.join(',',@{$self -> {'header'}})."\n" );
	  }
	}
	if ( $wrap ) {
	  foreach my $individual ( @{$self -> {'individuals'}} ) {
	    foreach my $row ( @{$individual -> subject_data} ) {
	      my @r_data;
	      for ( my $i = 0; $i <= $#secondary_columns ; $i++ ) {
		my $sstr = '';
		for ( my $j = 0; $j < scalar @{$secondary_columns[$i]} ; $j++ ) {
		  my $jstr = $j == 0 ? '' : ',';
		  if ( $secondary_columns[$i][$j][0] eq 'CONT' ) {
		    $sstr = $sstr.$jstr.'1';
		  } else {
		    my @data_row = split( /,/, $row );
		    $sstr = $sstr.$jstr.$data_row[$secondary_columns[$i][$j][1]];
		  }
		}
		push( @r_data, $sstr."\n" );
	      }
	      push( @form_data, @r_data );
	      my $pstr = '';
	      for ( my $i = 0; $i <= $#primary_columns ; $i++ ) {
		my $jstr = $i == 0 ? '' : ',';
		if ( $primary_columns[$i][0] eq 'CONT' ) {
		  $pstr = $pstr.$jstr.'0';
		} else {
		  my @data_row = split( /,/, $row );
		  $pstr = $pstr.$jstr.$data_row[$primary_columns[$i][1]];
		}
	      }
	      push( @form_data, $pstr."\n" );
	    }
	  }
	} else {
	  foreach my $individual ( @{$self -> {'individuals'}} ) {
	    foreach my $row ( @{$individual -> subject_data} ) {
	      push( @form_data, $row ."\n" );
	    }
	  }
	}
      }
end format_data

# }}} format_data

# {{{ drop_dropped

start drop_dropped
      {
	# This method removes columns that has '=DROP' value in the
	# model header as given by $INPUT. The model header must be
	# transfered to this method through the model_header
	# argument. The model_header argument should be a
	# two-dimensional array where each position in the first
	# dimension should be a reference to a 1*2 array holding the
	# column name and value. Any ignore-sign must be removed.

	debug -> die( message => 'model header must be defined' )
	  if ( $#model_header < 0 );
	# Important that the drop_dropped method of the model::problem
	# class is in sync with this method.
	$self -> synchronize;

	$self -> {'header'} = [];
	my @drop;
	my $counter = 1;
	for( my $i = 0; $i <= $#model_header; $i++ ) {
	  $self -> {'idcolumn'} = $counter if ( $model_header[$i][0] eq 'ID' );
	  if( ( $model_header[$i][1] eq 'DROP' or 
		$model_header[$i][1] eq 'SKIP' ) and
	      not $model_header[$i][0] =~ /DAT(E|1|2|3)/ ) {
	    push( @drop, 1 );
	  } else {
	    $counter++;
	    push( @drop, 0 );
	    push( @{$self -> {'header'}}, $model_header[$i][0] );
	  }
	}

	foreach my $individual ( @{$self -> {'individuals'}} ) {
	  $individual -> drop_columns( drop => \@drop );
	}
	
	$self -> {'synced'} = 0;
#	$Data::Dumper::Maxdepth = 2;
#	die Dumper $self;
#	die Dumper $self -> {'individuals'};
      }
end drop_dropped

# }}} drop_dropped

# {{{ wrap
start wrap
      {
	$self -> synchronize;
	$self -> cont_column( $cont_column ) if ( defined $cont_column );
	$self -> wrap_column( $wrap_column ) if ( defined $wrap_column );
	$self -> prepare_wrap( model_header => \@model_header );
	@secondary_columns = @{$self -> {'secondary_columns'}}
	  if ( defined $self -> {'secondary_columns'} );
	@primary_columns = @{$self -> {'primary_columns'}}
	  if ( defined $self -> {'primary_columns'} );
	$self -> synced(0);
      }
end wrap
# }}} wrap

# {{{ unwrap
start unwrap
      {
	$self -> {'cont_column'} = undef;
	$self -> {'wrap_column'} = undef;
	$self -> {'secondary_columns'} = undef;
	$self -> {'primary_columns'} = undef;
      }
end unwrap
# }}} unwrap

# {{{ prepare_wrap

start prepare_wrap
      {
	my $cont_column = $self -> {'cont_column'};
	my $wrap_column = $self -> {'wrap_column'};
	debug -> die( message => 'cont_column ('.$cont_column.') must be less or equal '.
		      'to the requested number of columns in each row ('.
		      ($wrap_column).')' )
	  if ( $cont_column > $wrap_column );
	my @header;
	if ( scalar @model_header > 0 ) {
	  @header = @model_header;
	} else {
	  @header = @{$self -> {'header'}};
	}

	my ( @primary, @secondary, @date_columns );

	for ( my $i = 0; $i <= $#header; $i++ ) {
	  my $name  = ref( $header[$i] ) eq 'ARRAY' ? $header[$i][0] : $header[$i];
	  my $value = ref( $header[$i] ) eq 'ARRAY' ? $header[$i][1] : undef;
	  next if ( $name eq 'ID' );
	  my $found = 0;
	  foreach my $prim ( @primary_column_names ) {
	    if ( not $found and
		 ( $name eq $prim or $value eq $prim ) ) {
	      push( @primary, [$name, $i, $value] );
	      $found = 1;
	      my $col = ($#primary+2)>= $cont_column ? ($#primary+3) : ($#primary+2);
	      push( @date_columns, $col ) if ( $name =~ /DAT(E|1|2|3)/ );
	    }
	  }
	  push( @secondary, [$name, $i, $value] ) if ( not $found );
	}

	my $prim_num = scalar @primary;
	debug -> die( message => 'The number of primary columns (that need to '.
		      'be part of the row with CONT=0) ('.($prim_num+1).
		      ') is larger than the required number of columns (wrap_column='.
		      $wrap_column.') - 1' )
	  if ( scalar $prim_num > ($wrap_column-2) );

	my ( $i, $dum ) = ( 0, 1 );
	my @tmp;
	for ( my $j = 1; $j <= $wrap_column; $j++ ) {
	  if( $j == 1 ) {
	    push( @tmp, ['ID', $self -> {'idcolumn'}-1] );
	  } elsif ( $j == $wrap_column ) {
	    if ( $j == $cont_column ) {
	      push( @tmp, ['CONT', undef] );
	    } else {
	      my $val;
	      if ( defined $primary[$i] ) {
		$val = $primary[$i];
	      } elsif ( defined $secondary[0] ) {
		$val = shift(@secondary);
	      } else {
		$val = ['XX'.$dum++,$self -> {'idcolumn'}-1];
	      }
	      push( @tmp, $val );
	      $i++;
	    }
	    push( @{$self -> {'primary_columns'}}, @tmp );
	  } else {
	    if ( $j == $cont_column ) {
	      push( @tmp, ['CONT', undef] );
	    } else {
	      if ( $i <= $#primary ) {
		push( @tmp, $primary[$i] );
		$i++;
	      } else {
		my $val = defined $secondary[0] ? shift(@secondary) :
		  ['XX'.$dum++,$self -> {'idcolumn'}-1];
		push( @tmp, $val );
	      }
	    }
	  }
	}

	my $i = 0;
	while ( $i <= $#secondary ) {
	  my @tmp;
	  for ( my $j = 1; $j <= $wrap_column; $j++ ) {
	    if( $j == 1 ) {
	      push( @tmp, ['ID', $self -> {'idcolumn'}-1] );
	    } elsif ( $j == $wrap_column ) {
	      if ( $j == $cont_column ) {
		push( @tmp, ['CONT', undef] );
	      } else {
		my $val = defined $secondary[$i] ? $secondary[$i] :
		  ['XX'.$dum++,$self -> {'idcolumn'}-1];
		push( @tmp, $val );
		$i++;
	      }
	      unshift( @{$self -> {'secondary_columns'}}, \@tmp );
	    } else {
	      if ( $j == $cont_column ) {
		push( @tmp, ['CONT', undef] );
	      } else {
		my $isdate = 0;
		if ( $#date_columns >= 0 ) {
		  foreach my $col ( @date_columns ) {
		    # This is a date column which may have to be dropped
		    # and thus will not appear as a secondary
		    # column. Nothing should be pushed. The indexes in
		    # model::problem::pk::_format_record will be ok.
		    $isdate = 1 if ( $col == $j ) ;
		  }
		}
		if ( $isdate ) {
		  push( @tmp, ['XX'.$dum++,$self -> {'idcolumn'}-1] );
		} else {
		  if ( $i <= $#secondary ) {
		    push( @tmp, $secondary[$i] );
		    $i++;
		  } else {
		    push( @tmp, ['XX'.$dum++,$self -> {'idcolumn'}-1] );
		  }
		}
	      }
	    }
	  }
	}
      }
end prepare_wrap

# }}} prepare_wrap

# {{{ have_missing_data

start have_missing_data
      {
	# Either I<column> or I<column_head> must be specified.
	#
	# This method looks through the data column with index I<column> or
	# (optional) header name I<column_head> and returns O if no missing
	# data indicator was found or 1 otherwise.

	$self -> synchronize;
	my $first_id = $self -> {'individuals'}[0];
	debug -> die( message => "No individuals defined in data object based on ".
		      $self -> full_name ) unless ( defined $first_id );
	my @data_row = split( /,/ , $first_id -> subject_data -> [0] );
	unless ( defined $column  && defined( $data_row[$column-1] ) ) {
	  unless(defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})){
	    die "Error in data -> have_missing_data: unknown column: \"$column_head\" or invalid column number: \"$column\"\n";
	  } else {
	    $column = $self -> {'column_head_indices'}{$column_head};
	  }
	}
	$self -> flush if ( $self -> {'target'} eq 'disk' );

	# In case anyone wonders, the ternary statment ( bool ? true :
	# false ) below will possibly make a minuscle memory
	# optimization. But hey, why not :)

	$return_value = defined $self -> {'have_missing_data'} ? $self -> {'have_missing_data'} -> {$column} : 0;
      }
end have_missing_data

# }}} have_missing_data

# {{{ merge
start merge
      {
	#$self -> synchronize;
        push( @{$self -> {'individuals'}}, @{$mergeobj -> individuals} );
      }
end merge
# }}} merge

# {{{ max

start max
      {
	# Either column or column_head must be specified. Column_head must be a string that
	# identifies a column in the (optional ) data file header.

# The if-statement below used to be a cache of allready calculated
# means. But since individuals can be accessed in so many ways, we
# don't know when this cache should be updated. Its easier to
# recalculate the max. Maybe we can include this optimization in the
# future, if it turns out to be a bottleneck
#	my $tmp_column = $self -> {'column_head_indices'}{$column_head};
#	if ( defined $self -> {'max'}[$tmp_column] ) {
#	  $return_value = $self -> {'max'}[$tmp_column] ;
#	} else {
	  $self -> synchronize;
	  my $first_id = $self -> {'individuals'}[0];
	  debug -> die( message => "data -> max: No individuals defined in data object based on " . 
			$self -> full_name ) unless defined $first_id;

	  my @data_row = split( /,/ , $first_id -> subject_data ->[0] );

	  unless ( defined $column  && defined( $data_row[$column-1] ) ) {
	    unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	      die "Error in data -> max: unknown column: \"$column_head\" or invalid column number: \"$column\"\n";
	    } else {
	      $column = $self -> {'column_head_indices'}{$column_head};
	    }
	  }
	  foreach my $individual ( @{$self -> {'individuals'}} ) {
	    my $ifactors = $individual -> factors( 'column' => $column );
	    foreach ( keys %{$ifactors} ) {
	      next if ( $_ == $self -> {'missing_data_token'} );
	      if ( defined ($return_value) ) {
		$return_value = $_ > $return_value ? $_ : $return_value;
	      } else {
		$return_value = $_;
	      }
	    }
	  }

#	  $self -> {'max'}[$column] = $return_value;
	  $self -> flush if ( $self -> {'target'} eq 'disk' );
#	}
      }
end max

# }}} max

# {{{ min

start min
      {
	# See L</max>.
	my $tmp_column = $self -> {'column_head_indices'}{$column_head};

# The if-statement below used to be a cache of allready calculated
# means. But since individuals can be accessed in so many ways, we
# don't know when this cache should be updated. Its easier to
# recalculate the min. Maybe we can include this optimization in the
# future, if it turns out to be a bottleneck
#	if ( defined $self -> {'min'}[$tmp_column] ) {
#	  $return_value = $self -> {'min'}[$tmp_column] ;
#	} else {
	  $self -> synchronize;
	  my $first_id = $self -> {'individuals'}[0];
	  die "data -> min: No individuals defined in data object based on ",
	    $self -> full_name,"\n" unless defined $first_id;
	
          my @data_row = split( /,/ , $first_id -> subject_data ->[0] );

	  unless ( defined $column  && defined( $data_row[$column-1] ) ) {
	    unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	      die "Error in data -> min: unknown column: \"$column_head\" or invalid column number: \"$column\"\n";
	    } else {
	      $column = $self -> {'column_head_indices'}{$column_head};
	    }
	  }
	  foreach my $individual ( @{$self -> {'individuals'}} ) {
	    my $ifactors = $individual -> factors( 'column' => $column );
	    foreach ( keys %{$ifactors} ) {
	      next if ( $_ == $self -> {'missing_data_token'} );
	      if ( defined ($return_value) ) {
		$return_value = $_ < $return_value ? $_ : $return_value;
	      } else {
		$return_value = $_;
	      }
	    }
	  }
#	  $self -> {'min'}[$column] = $return_value;
	  $self -> flush if ( $self -> {'target'} eq 'disk' );
#	}
      }
end min

# }}} min

# {{{ median

start median
      {
	  # See L</max>.
	$self -> synchronize;
	my $first_id = $self -> {'individuals'}[0];
	die "data -> median: No individuals defined in data object based on ",
	  $self -> full_name,"\n" unless defined $first_id;

	my @data_row = split( /,/ , $first_id -> subject_data ->[0] );

	unless ( defined $column  && defined( $data_row[$column-1] ) ) {
	  unless(defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})){
	    die "Error in data -> median: unknown column: \"$column_head\" or invalid column number: \"$column\"\n";
	  } else {
	    $column = $self -> {'column_head_indices'}{$column_head};
	  }
	}
	
	if( defined $self -> {'median'}[$column] ){
	  return $self -> {'median'}[$column];
	}
	
	my @median_array;
	
	foreach my $individual ( @{$self -> {'individuals'}} ) {
	  if( $unique_in_individual ){
	    my $ifactors = $individual -> factors( 'column' => $column );
	    
	    foreach ( keys %{$ifactors} ) {
	      next if ( $_ == $self -> {'missing_data_token'} );
	      push( @median_array, $_ );
	    }
	  } else {
	    my $ifactors = $individual -> subject_data;
	    
	    for(my $i=0; $i<=$#{$ifactors}; $i++ ) {
	      my @data_row = split( /,/ , $ifactors -> [$i] );
	      next if ( $data_row[$column-1] == $self -> {'missing_data_token'} );
	      push(@median_array, $data_row[$column-1]);
	    }
	  }
	}
	@median_array = sort {$a <=> $b} @median_array ;
	
	if( @median_array % 2 ){
	  $return_value = $median_array[$#median_array / 2];
	} else {
	  $return_value = ( $median_array[@median_array / 2] + 
			    $median_array[(@median_array - 2) / 2] ) / 2;
	}    
	
	$self -> {'median'}[$column] = $return_value;
      }
end median

# }}} median

# {{{ mean

start mean
  {
     # Returns mean value of a column
     # If a individual contains more then 1 value (i.e. if an
     # individual has different values in different samples a mean
     # value of all individuals if calculate first, then the mean
     # value of the column If hi_cutoff is defined the mean function
     # will cut all value below the cutoff, and set their value to
     # 0. It's used to calculate the HI-mean/LOW-mean of a column for
     # e.g. Hockey-stick covariates If both hi_cutoff and low_cutoff
     # are defined only the hi_cutoff will be used.  See L</max>.
     my $tmp_column = $self -> {'column_head_indices'}{$column_head};
     $self -> synchronize;
     my $first_id = $self -> {'individuals'}[0];
       die "data -> mean: No individuals defined in data object based on ",
	$self -> full_name,"\n" unless defined $first_id;

     my @data_row = split( /,/, $first_id -> subject_data ->[0] );

     unless ( defined $column  && defined( $data_row[$column-1] ) ) {
       unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	 die "Error in data -> mean: unknown column: \"$column_head\" or invalid column number: \"$column\"\n";
       } else {
	      $column = $self -> {'column_head_indices'}{$column_head};
	 }
     }
      
	## Here the calculation starts
	my $num_individuals = 0;
	my $sum = 0;
	
     my $all_data_rows=0;
	foreach my $individual ( @{$self ->{'individuals'}} ) {
	  
	  my $ifactors = $individual -> subject_data;
	  my $individual_sum = 0;
	  my $data_rows = 0;
	  for(my $i=0; $i<=$#{$ifactors}; $i++ ) {

	    # data is stored in strings. We need to split them into an
	    # array.

	    my @data_row = split( /,/, $ifactors -> [$i] );
	    if ( $data_row[$column-1] == $self -> {'missing_data_token'} ) {
#	      print "Skipping row with missing data\n";
	      next;
	    }

	    if( defined $subset_column and not eval ( $data_row[$subset_column-1].$subset_syntax ) ) {
#	      print "Skipping row outside subset: syntax: ".($subset_column-1)." $subset_syntax\n";
	      next;
	    }

	    if (defined $hi_cutoff) {
	      if ($data_row[$column-1]>$hi_cutoff) {
		$individual_sum += $data_row[$column-1]-$hi_cutoff;
	      }
	    }
	    else {
	      if (defined $low_cutoff) {
		if ($data_row[$column-1]<$low_cutoff) {
		  $individual_sum += $low_cutoff - $data_row[$column-1];
		}
	      }
	      else {
		$individual_sum += $data_row[$column-1];
	      }
	    }
	    $data_rows++;
	  }
	  if( $global_mean ) {
	    $sum += $individual_sum;
	    $num_individuals += $data_rows;
	  } else {
	    if( $data_rows != 0 ) {
	      $sum += $individual_sum/$data_rows;
	    }
	    $num_individuals ++;
	  }
	  $all_data_rows += $data_rows;
	}
     if( $num_individuals != 0 ) {
       $return_value = $sum / $num_individuals;
     }
#     print "DR: $all_data_rows\n";
#     print "\nNIM: $num_individuals $return_value\n";
}

end mean

# }}} mean

# {{{ sd

start sd
  {
    # This sub returns standard deviation for a specific column
    # If there are more than one sample/individual the value used for that specific
    # individual is the mean value of its samples.
    # The cut-offs are for hockey stick variables. I.e. If one individual value is
    # lower than the hi-cutoff the individual value will be zero.
    # HI_cutoff is used to calculate the HI-mean of a column.
    # If cut_off is undef it won't be used
    # See L</max>.
     my $tmp_column = $self -> {'column_head_indices'}{$column_head};
     $self -> synchronize;
     my $first_id = $self -> {'individuals'}[0];
     debug -> die( message => "No individuals defined in data object based on ".
		   $self -> full_name ) unless defined $first_id;
     
     my @data_row = split( /,/ , $first_id -> subject_data ->[0] );

     unless ( defined $column  && defined( $data_row[$column-1] ) ) {
       unless (defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})) {
	 debug -> die( message => "Unknown column: \"$column_head\" or "
		       ."invalid column number: \"$column\"" );
       } else {
	 $column = $self -> {'column_head_indices'}{$column_head};
       }
     }
     
     ## Here the calculation starts
     my $num_individuals = 0;
     my $sum = 0;
     my $mean;
     if (defined $hi_cutoff) {
       $mean = $self->mean(column   => $column,
			   hi_cutoff => $hi_cutoff,
			   global_mean => $global_sd );
     } elsif (defined $low_cutoff) {	  
       $mean = $self->mean(column   => $column,
			   low_cutoff => $low_cutoff,
			   global_mean => $global_sd );
     } else {
       $mean = $self->mean( column        => $column,
			    subset_column => $subset_column,
			    subset_syntax => $subset_syntax,
			    global_mean => $global_sd );
     }

     foreach my $individual ( @{$self -> {'individuals'}} ) {
       my $ifactors = $individual -> subject_data;
       my $individual_sum = 0;
       my $data_rows = 0;
       for(my $i=0; $i<=$#{$ifactors}; $i++ ) {

	 # data is stored in strings. We need to split them into an
	 # array.

	 my @data_row = split( /,/, $ifactors -> [$i] );

	 if ( $data_row[$column-1] == $self -> {'missing_data_token'} ) {
#	   print "Skipping row with missing data\n";
	   next;
	 }
	 
	 if( defined $subset_column and not eval ( $data_row[$subset_column-1].$subset_syntax ) ) {
#	   print "Skipping row outside subset: syntax: ".($subset_column-1)." $subset_syntax\n";
	   next;
	 }

	 if (defined $hi_cutoff) {
	   if ($data_row[$column-1]>$hi_cutoff) {
	     if( $global_sd ) {
	       $individual_sum += ($data_row[$column-1] - $hi_cutoff - $mean) ** 2;
	     } else {
	       $individual_sum += $data_row[$column-1]-$hi_cutoff;
	     }
	   }
	 } else {
	   if (defined $low_cutoff) {
	     if ($data_row[$column-1]<$low_cutoff) {
	       if( $global_sd ) {
		 $individual_sum += ($low_cutoff - $data_row[$column-1] - $mean) ** 2;
	       } else {
		 $individual_sum += $low_cutoff - $data_row[$column-1];
	       }
	     }
	   } else {
	     if( $global_sd ) {
	       $individual_sum += ($data_row[$column-1] - $mean) ** 2;
	     } else {
	       $individual_sum += $data_row[$column-1];
	     }
	   }
	 }
	 $data_rows++;
       }
       if( $global_sd ) {
	 $sum += $individual_sum;
	 $num_individuals += $data_rows;
       } else {
	 if( $data_rows != 0 ) {
	   $sum += ($individual_sum/$data_rows - $mean) ** 2;
	 }
	 $num_individuals++;
       }
     }
     if( $num_individuals < 2 ) {
       $return_value = 0;
     } else {
       if( $num_individuals != 0 ) {
	 $return_value = (1/($num_individuals-1)*$sum) ** 0.5;
       }
     }
   }

end sd

# }}} sd

# {{{ range

start range
      {
	# See L</max>.
	my $tmp_column = $self -> {'column_head_indices'}{$column_head};
	if ( defined $self -> {'range'}[$tmp_column] ) {
	  $return_value = $self -> {'range'}[$tmp_column];
	} else {
	  my $old_target = $self -> {'target'};
	  $self -> {'target'} = 'mem';
	  $self -> synchronize;
	  $return_value = $self -> max( column      => $column,
					column_head => $column_head ) -
					  $self -> min( column      => $column,
							column_head => $column_head );
	  $self -> {'range'}[$column] = $return_value;
	  if ( $old_target eq 'disk' ) {
	    $self -> flush if ( $self -> {'target'} eq 'disk' );
	    $self -> {'target'} = 'disk';
	  }
	}
      }
end range

# }}} range

# {{{ recalc_column

start recalc_column
      {
	  # Recalculates a column based on expression. Also, see L</max>. 
	$self -> synchronize;
	
	# Check if $column(-index) is defined and valid, else try to find index using column_head
	my $first_id = $self -> {'individuals'}[0];
	die "data -> recalc_column: No individuals defined in data object based on ",
	  $self -> full_name,"\n" unless defined $first_id;

	my @data_row = split( /,/ , $first_id -> subject_data ->[0] );

	unless ( defined $column  && defined( $data_row[$column-1] ) ) {
	  if(defined($column_head) && defined($self -> {'column_head_indices'}{$column_head})){
	    die "Error in data -> recalc_column: unknown column: \"$column_head\" or column number: \"$column\"\n";
	  } else {
	    $column = $self -> {'column_head_indices'}{$column_head};
	  }
	}
	
	for my $individual ( @{$self -> {'individuals'}} ) {
	  $individual -> recalc_column( column     => $column,
					expression => $expression );
	}
      }
end recalc_column

# }}} recalc_column

# {{{ renumber_ascending

start renumber_ascending
      {
# Renumbers the individuals (changes the subject identifiers) so that
# all have unique integer numbers starting with start_at and
# ascending. The primary use of this
# method is not to order the individuals after their identifiers but to
# ensure that all individuals have unique identifiers.

	$self -> synchronize;
	foreach my $individual ( @{$self -> {'individuals'}} ) {
	  $individual -> idnumber ( $start_at++ );
	}
	$self -> {'synced'} = 0;
      }
end renumber_ascending

# }}} renumber_ascending

# {{{ renumber_descending

start renumber_descending
      {
	  # See L</renumber_ascending>.
	$self -> synchronize;
        foreach my $individual ( @{$self -> {'individuals'}} ) {
	  $individual -> idnumber ( $start_at-- );
        }
	$self -> {'synced'} = 0;
      }
end renumber_descending

# }}} renumber_descending

# {{{ single_valued_data

start single_valued_data
      {
	# Usage:
	#
	# ($single_value_data_set, $remainder, $column_indexes) =
	#      $data_object -> single_valued_data( subset_name         => 'subset.dta',
	#			                   remainder_name      => 'remainder.dta',
	#			                   target              => 'disk',
	#			                   do_not_test_columns => [1..18,24,26];
	#
	# my $single_value_column_indexes = $column_indexes -> [0];
	# my $all_other_column_indexes    = $column_indexes -> [1];
	#
	# Analyses the content of each column, based on the
	# ID column, and returns two new data objects: One
	# that contains all columns that is has only one value per
	# individual and one that contains the
	# remainding data. This is useful for creating compact 'extra'
	# data sets that can be read in via user-defined sub-routines
	# when the number of columns needed exceeds the maximum that
	# NONMEM allows (e.g. 20 in NONMEM version V).
	#
	# The I<do_not_test_columns> argument specifies on which columns
	# to skip the single value test

	my @multi_value_flags;
	my @individuals = @{$self -> {'individuals'}};
	# Initiate the flags:
	if ( defined $individuals[0] ) {
	  my @data = @{$individuals[0] -> {'subject_data'}};
	  my @data_row = split( /,/ , $data[0] );
	  for ( my $i = 0; $i < scalar @data_row; $i++ ) {
	    my $dnt_flag = 0;
	    foreach my $dntc ( @do_not_test_columns ) {
	      $dnt_flag = 1 if ( $i == $dntc - 1 );
	    }
	    $multi_value_flags[$i] = $dnt_flag;
	  }
	} else {
	  die "data -> single_valued_data: No data in ID number 1\n";
	}
	# Collect the stats
	for ( my $id = 0; $id <= $#individuals; $id++ ) {
	  my @data = @{$individuals[$id] -> {'subject_data'}};
	  my @data_row = split( /,/, $data[0] );
	  for ( my $j = 0; $j < scalar @data_row; $j++ ) {
	    my %col_unique;
	    for ( my $i = 0; $i <= $#data; $i++ ) {
	      my @data_row = split( /,/ , $data[$i] );
	      $col_unique{$data_row[$j]}++;
	    }
	    my $factors = scalar keys %col_unique;
	    $multi_value_flags[$j]++ if ( $factors > 1 );
	  }
	}
	for ( my $i = 0; $i <= $#multi_value_flags; $i++ ) {
	  if ( $multi_value_flags[$i] ) {
	    push ( @{$column_indexes[1]}, $i + 1);
	  } else {
	    push ( @{$column_indexes[0]}, $i + 1);
	  }
	}
	( $single_value_data_set, $remainder ) =
	  $self -> subset_vertically( column_indexes      => $column_indexes[0],
				      subset_name         => $subset_name,
				      return_remainder    => 1,
				      remainder_name      => $remainder_name,
				      target              => $target,
				      keep_first_row_only => 1);
      }
end single_valued_data

# }}}

# {{{ subset_vertically

start subset_vertically
      {
	# Usage:
	#
	# $subset = $data_object -> subset_vertically ( column_indexes => [1,2,6],
	#                                               subset_name    => 'subset.dta' );
	#
	# This basic usage returns a new data object containing
	# columns 1,2 and 6 from the original data plus the
	# idcolumn. The new data object will be associated with the
	# file 'subset.dta'.
	#
	# You get the remaining data, i.e. the original data minus
	# the created subset by specifying
	#
	# ( $subset, $remainder ) =
	#      $data_object -> subset_vertically ( column_indexes   => [1,2,6],
	#                                          subset_name      => 'subset.dta',
	#                                          return_remainder => 1,
	#                                          remainder_name   => 'remainder.dta' );
	#
	# If you would like to flush the created data sets to disk and
	# save memory, set the I<target> argument to 'disk'. The
	# default value 'mem' will keep the whole data object in RAM.
	#
	# The I<keep_first_row_only> argument can be used to reduce
	# the size of the subset data obejct by excluding all but the
	# first row of data from each individual.
	#
	my @individuals = @{$self -> {'individuals'}};
	# Create remainder index array if necessary
	my @remainder_indexes;
	if ( defined $individuals[0] ) {
	  my @data = @{$individuals[0] -> {'subject_data'}};
	  my $idcolumn = $individuals[0] -> {'idcolumn'};
#	  print "IC: $idcolumn\n";
	  my $id_flag = 0;
	  foreach my $use_index ( @column_indexes ) {
	    $id_flag = 1 if ( $use_index == $idcolumn );
	  }
	  if ( $return_remainder ) {
#	    @remainder_indexes = ( $idcolumn );
	    for ( my $i = 0; $i < scalar split(/,/,$data[0]); $i++ ) {
	      my $rem_flag = 1;
	      foreach my $use_index ( @column_indexes ) {
		$rem_flag = 0 if ( $i == $use_index -1 );
# or
#				   $i == $idcolumn -1 );
	      }
	      push( @remainder_indexes, $i + 1 ) if ( $rem_flag );
	    }
	    unshift( @remainder_indexes, $idcolumn ) if ( $id_flag );
	  }
	  unshift( @column_indexes, $idcolumn ) unless ( $id_flag );
	} else {
	  die "data -> single_valued_data: No data in ID number 1\n";
	}

	my @new_ids;
	my @new_ids_2;
	for ( my $id = 0; $id <= $#individuals; $id++ ) {
	  my $idnumber = $individuals[$id] -> idnumber;
	  my $idcolumn = $individuals[$id] -> idcolumn;
	  my @data = @{$individuals[$id] -> {'subject_data'}};
	  my @new_data;
	  my @new_data_2;
	  my $use_rows = $keep_first_row_only ? 0 : $#data;
	  for ( my $i = 0; $i <= $use_rows; $i++ ) {
	    my @new_row;
	    my @data_row = split( /,/, $data[$i] );
	    foreach my $use_index ( @column_indexes ) {
	      push( @new_row, $data_row[$use_index-1] );
	    }
#	    print "@new_row $#new_row\n";
	    push( @new_data, join( ',', @new_row ) );
	  }
	  for ( my $i = 0; $i <= $#data; $i++ ) {
	    if ( $return_remainder ) {
	      my @new_row_2;
	      my @data_row = split( /,/, $data[$i] );
	      foreach my $use_index ( @remainder_indexes ) {
		push( @new_row_2, $data_row[$use_index-1] );
	      }
#	      print "@new_row_2 $#new_row_2\n";
	      push( @new_data_2, join( ',' , @new_row_2 ) );
	    }
	  }
	  my $new_id = data::individual -> new( idnumber     => $idnumber,
						idcolumn     => $idcolumn,
						subject_data => \@new_data );
	  push( @new_ids, $new_id );
	  if ( $return_remainder ) {
	    my $new_id_2;
	    $new_id_2 = data::individual -> new( idnumber     => $idnumber,
						 idcolumn     => $idcolumn,
						 subject_data => \@new_data_2 );
	  push( @new_ids_2, $new_id_2 );
	  }
	}
	my @header = @{$self -> {'header'}};
	my @new_header;
	foreach my $use_index ( @column_indexes ) {
	  push( @new_header, @header[$use_index-1] );
	}
	my $comment;
	if( defined $self -> {'comment'} ){
	  my @comment = @{$self -> {'comment'}};
	  $comment = \@comment;
	}
	$subset = data -> new ( filename	     => $subset_name,
				directory	     => $self -> {'directory'},
				ignoresign	     => $self -> {'ignoresign'},
				header		     => \@new_header,
				comment		     => $comment,
				individuals	     => \@new_ids,
				target		     => $target,
				ignore_missing_files => 1 );
	if ( $return_remainder ) {
	  my @new_header_2;
	  foreach my $use_index ( @remainder_indexes ) {
	    push( @new_header_2, @header[$use_index-1] );
	  }
	  $remainder = data -> new ( filename	          => $remainder_name,
				     directory	          => $self -> {'directory'},
				     ignoresign	          => $self -> {'ignoresign'},
				     header		  => \@new_header_2,
				     comment		  => $comment,
				     individuals	  => \@new_ids_2,
				     target		  => $target,
				     ignore_missing_files => 1 );
	}
      }
end subset_vertically

# }}}

# {{{ subsets

start subsets
      {
# 	if ( defined $expression and defined $bins ) {
# 	  die "data -> subset: expression and bins may not both be specified\n";
# 	}
# 	if ( not ( defined $expression or defined $bins ) ) {
# 	  die "data -> subset: expression or bins must be specified\n";
# 	}
	$self -> synchronize;
	my @header  = @{$self -> {'header'}};
	my @comment = defined $self -> {'comment'} ? @{$self -> {'comment'}} : ();
	my @subset_ids= ();
	my %rnd_ids;
	my $key = 0;
	my @ids = @{$self -> {'individuals'}};
	if ( defined $stratify_on ) {
	  my $work_data = $self -> copy( filename => 'work_data.dta',
					 target   => 'mem' );
	  my %strata = %{$work_data -> factors( column => $stratify_on )};
#	  $Data::Dumper::Maxdepth = 1;
#	  print Dumper \%strata;

	  while ( my ( $factor, $keys ) = each %strata ) {
	      foreach my $key ( @{$keys} ) {
		  my $rnd_num = rand;
		  while ( defined $rnd_ids{$factor}{$rnd_num} ) {
		      $rnd_num = rand;
		  }
		  $rnd_ids{$factor}{$rnd_num} = $ids[$key];
	      }
	  }
	  my $first = 1;
	  while ( my ( $factor, $rnd_nums ) = each %rnd_ids ) {
	      my @sort_rnd_nums = sort { $a <=> $b } keys %{$rnd_nums};
	      for ( my $i = 0; $i <= $#sort_rnd_nums; $i ) {
		  for ( my $j = 0; $j < $bins; $j++ ) {
		      if ( $first ) {
			  push( @subset_ids, [$rnd_ids{$factor}{$sort_rnd_nums[$i]} -> copy] );
			  push( @incl_ids, [$rnd_ids{$factor}{$sort_rnd_nums[$i]} -> idnumber] );
		      } else {
			  push( @{$subset_ids[$j]}, $rnd_ids{$factor}{$sort_rnd_nums[$i]} -> copy );
			  push( @{$incl_ids[$j]}, $rnd_ids{$factor}{$sort_rnd_nums[$i]} -> idnumber );
		      }
		      $i++;
		      last if $i > $#sort_rnd_nums;
		  }
		  $first = 0;
	      }
	  }
	  for ( my $j = 0; $j < $bins; $j++ ) {
	    my $sdata = data -> new ( header               => \@header,
				      comment              => \@comment,
				      ignoresign           => $self -> {'ignoresign'},
				      individuals          => $subset_ids[$j],
				      ignore_missing_files => 1,
				      target               => 'disk',
				      idcolumn             => $self -> {'idcolumn'},
				      filename             => "subset_$j.dta" );
	    #$sdata -> _write;
	    push( @subsets, $sdata );
	  }
	} else {
	  for ( my $i = 0; $i <= $#ids; $i++ ) {
	    my $rnd_num = rand;
	    while ( defined $rnd_ids{$rnd_num} ) {
	      $rnd_num = rand;
	    }
	    $rnd_ids{$rnd_num} = $ids[$i];
	  }
	  my @keys = sort { $a <=> $b } keys %rnd_ids;
	  my $first = 1;
	  for ( my $i = 0; $i <= $#keys; $i ) {
	    for ( my $j = 0; $j < $bins; $j++ ) {
	      if ( $first ) {
		push( @subset_ids, [$rnd_ids{$keys[$i]} -> copy] );
		push( @incl_ids, [$rnd_ids{$keys[$i]} -> idnumber] );
	      } else {
		push( @{$subset_ids[$j]}, $rnd_ids{$keys[$i]} -> copy );
		push( @{$incl_ids[$j]}, $rnd_ids{$keys[$i]} -> idnumber );
	      }
	      $i++;
	      last if $i > $#keys;
	    }
	    $first = 0;
	  }
	  for ( my $j = 0; $j < $bins; $j++ ) {
	    my $sdata = data -> new ( header               => \@header,
				      comment              => \@comment,
				      ignoresign           => $self -> {'ignoresign'},
				      individuals          => $subset_ids[$j],
				      ignore_missing_files => 1,
				      target               => $target,
				      idcolumn             => $self -> {'idcolumn'},
				      filename             => "subset_$j.dta" );
	    #$sdata -> _write;
	    push( @subsets, $sdata );
	  }
	}
      }
end subsets

# }}} subsets

# {{{ subset

start subset
      {
	$self -> synchronize;
	my @header  = @{$self -> {'header'}};
	my @comment = defined $self -> {'comment'} ? @{$self -> {'comment'}} : ();
	my @subset_inds = ();
	my $key = 0;
	foreach my $individual ( @{$self -> {'individuals'}} ) {
	  if ( $individual -> evaluate_expression( column     => $based_on,
						   expression => $expression ) ) {
	    push( @subset_inds, $individual -> copy );
	    push( @incl_individuals, $individual -> idnumber );
	    push( @included_keys, $key );
	  }
	  $key++;
	}
	$subset = data -> new ( header      => \@header,
				comment     => \@comment,
				ignoresign  => $self -> {'ignoresign'},
				individuals => \@subset_inds,
				idcolumn    => $self -> {'idcolumn'},
				filename    => "subset.dta" );
      }
end subset

# }}} subset

# {{{ target

start target
      {
	if ( $parm eq 'disk' and $self -> {'target'} eq 'mem' ) {
	  $self -> {'target'} = 'disk';
	  $self -> flush;
	} elsif ( $parm eq 'mem' and $self -> {'target'} eq 'disk' ) {
	  $self -> {'target'} = 'mem';
	  $self -> synchronize;
	}
      }
end target

# }}}

# {{{ _write

start _write
    {
      die "ERROR: data -> _write: No filename set in data object.\n"
	  if( $filename eq '' );

#      $Data::Dumper::Maxdepth = 2;
#      die Dumper $self -> {'individuals'};

      if( not defined $self -> {'individuals'} ){

	# If we don't have any individuals and write to a new
	# filename, we must first read individuals from the old
	# file. A call to synchronize will do that. There is no risk
	# of a infinite loop here since synchronize allways writes to
	# "full_name".

	unless( $filename eq $self -> full_name ){
	  $self -> synchronize;
	} 
      }
      
      open(FILE,">$filename") || 
	  die "Could not create $filename\n";
      my $data_ref = $self -> format_data;
      my @data = @{$data_ref};
      for ( @data ) {
	print ( FILE );
      }
      close(FILE);

#       if ( $PsN::config -> {'_'} -> {'use_database'} and
# 	   $self -> {'use_data_table'} ) {
# 	# Backslashes messes up the sql syntax
# 	my $file_str = $self->{'filename'};
# 	my $dir_str = $self->{'directory'};
# 	$file_str =~ s/\\/\//g;
# 	$dir_str =~ s/\\/\//g;

# 	# md5sum
# 	my $md5sum = md5_hex(OSspecific::slurp_file($self-> full_name ));
# 	my ( $date_str, $time_str );
# 	if ( $Config{osname} eq 'MSWin32' ) {
# 	  $date_str = `date /T`;
# 	  $time_str = ' '.`time /T`;
# 	} else {
# 	  # Assuming UNIX
# 	  $date_str = `date`;
# 	}
# 	chomp($date_str);
# 	chomp($time_str);
# 	my $date_time = $date_str.$time_str;
# 	my $dbh = DBI -> connect("DBI:mysql:host=".$PsN::config -> {'_'} -> {'database_server'}.
# 			       ";databse=".$PsN::config -> {'_'} -> {'project'},
# 				 $PsN::config -> {'_'} -> {'user'},
# 			        $PsN::config -> {'_'} -> {'password'},
# 				 {
# 				  'RaiseError' => 1});
# 	my $sth;
# 	if ( defined $self -> {'data_id'} ) {
# 	  $sth = $dbh -> prepare( "UPDATE ".$PsN::config -> {'_'} -> {'project'}.
# 			       ".data ".
# 				  "SET filename='$file_str',date='$date_time',".
# 				  "directory='$dir_str',md5sum='$md5sum' ".
# 				  "WHERE data_id='".$self -> {'data_id'}."'" );
# 	  $sth -> execute or debug -> die( message => $sth->errstr ) ;
# 	} else {
# 	  $sth = $dbh -> prepare("INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
# 			       ".data (filename,date,directory,md5sum) ".
# 				 "VALUES ('$file_str', '$date_time', '$dir_str','".
# 				 $md5sum."' )");
# 	  $sth -> execute;
# 	  $self -> {'data_id'} = $sth->{'mysql_insertid'};
# 	}
# 	$sth -> finish;
# 	$dbh -> disconnect;
#       }
    }
end _write

# }}} _write

# {{{ flush

start flush
    {
      # synchronizes the object with the file on disk and empties
      # most of the objects attributes to save memory.
      if( defined $self -> {'individuals'} and
	  ( !$self -> {'synced'} or $force ) ) {
	$self -> _write;
      }
#      $self -> {'header'} = undef;
      $self -> {'comment'} = undef;
      $self -> {'individuals'} = undef;
      $self -> {'synced'} = 0;
#      $self -> {'column_head_indices'} = undef; # kajsa comment 080211
      $self -> {'have_missing_data'} = undef;
    }
end flush

# }}} flush

# {{{ synchronize

start synchronize
    {
      # synchronizes the object with the file on disk	  
      unless( $self -> {'synced'} ){
	if( defined $self -> {'individuals'} and
	    scalar @{$self -> {'individuals'}} > 0 ){
	  # We should not read new data from file if we 
	  # have an individuals defined?
	  # Perhaps there should be an attribute
	  # 'from_file' that overrides this and reads in
	  # the data from the file specified in filename
	  # and overwrites whatever the object already
	  # contains?
# 	    if( -e $self -> {'filename'} ){
# 	      $self -> _read_header;
# 	      $self -> _read_individuals;
# 	    }
	  $self -> _write;
	} else {
	  if( -e $self -> full_name ){
	    unless( defined $self -> {'header'} and scalar @{$self -> {'header'}} > 0 ){
	      $self -> _read_header;
	    }
	    $self -> _read_individuals;
	  } else {
	    debug -> die( message => "Fatal error: datafile: " . $self -> full_name . " does not exist." );
	    return;
	  }
	}
      }
      my $i = 1;
      foreach my $head ( @{$self -> {'header'}} ){
	$self -> {'column_head_indices'} -> {$head} = $i;
	$i++;
      }
      $self -> {'synced'} = 1;
    }
end synchronize

# }}} synchronize

# {{{ _fisher_yates_shuffle

start _fisher_yates_shuffle
      {
        my $arr_ref = $parm{'array'};
	debug -> warn( level   => 1,
		       message => "Array of zero length received" )
	  if ( scalar @{$arr_ref} < 1 );
        my $i;
        for ($i = @$arr_ref; --$i; ) {
	  my $j = random_uniform_integer(1,0,$i);
#          my $j = int rand ($i+1);
#	  print "$j $j_new\n";
          @$arr_ref[$i,$j] = @$arr_ref[$j,$i];
        }
      }
end _fisher_yates_shuffle

# }}} _fisher_yates_shuffle

# {{{ _read_header

start _read_header
      {
	my $filename   = $self -> full_name;
	my $ignoresign = $self -> ignoresign;
	my ( @data, @new_record, $row, $tmp_row, @header, $hdrstring );

	open(DATAFILE,"$filename") || 
	  die "Could not open $filename for reading";
	my $columns;
	while (<DATAFILE>) {
	  s/\s*\,\s*/\,/g;
	  $tmp_row    = $_;
	  #	@new_record = split(/\,|\s+/,$_);
	  if ( ! (/^\s*\d+|^\s*\./) ) {
            $data[$row] = $tmp_row;
            $row++;
	  } else {
            # We have reached the first data-row, return.
	    $columns = scalar split(/\,\s*|\s+/);
            last;
	  }
	}
	close(DATAFILE);

	if ( defined $self -> {'cont_column'} and not $self -> {'table_file'} ) {
	  my $data_len = $#data;
	  for ( my $i = $data_len; $i >= 0; $i-- ) {
	    my @arr = split(/\,\s*|\s+/,$data[$i]);
	    if ( $arr[$self -> {'cont_column'}-1] eq 'CONT' ) {
	      my $start = $i == $data_len ? 0 : 1;
	      for ( my $j = $start; $j <= $#arr; $j++ ) {
		if ( $j != ($self -> {'cont_column'}-1) ) {
		  push( @header, $arr[$j] );
		}
	      }
	      pop( @data );
	    }
	  }
	  # the \Q and \E here are to escape wierd ignoresigns
	  $header[0] =~ s/\Q$ignoresign\E//
	      if ( defined $self->ignoresign );
	  shift( @header ) if ( $header[0] eq "" );
	} else {
	  chomp( $hdrstring = pop(@data));
	  @header = split(/\,\s*|\s+/,$hdrstring);
	  # the \Q and \E here are to escape wierd ignoresigns
	  $header[0] =~ s/\Q$ignoresign\E//
	      if ( defined $self->ignoresign );
	  shift( @header ) if ( $header[0] eq "" );
	  if( $self -> {'table_file'} ) {
	    my @new_header;
	    for( my $i = 1; $i <= scalar @header; $i++ ) {
	      if( $header[$i-1] eq 'CONT' ) {
		if ( defined $self -> {'cont_column'} and not $i == $self -> {'cont_column'} ) {
		  debug -> warn( level   => 1,
				 message => "The supplied columns for the CONT data item (".
				 $self -> {'cont_column'}.") does not match the column where the CONT ".
				 "header was found ($i), using $i" );
		}
		$self -> {'cont_column'} = $i;
	      } else {
		push( @new_header, $header[$i-1] );
	      }
	    }
	    @header = @new_header;
	    for( my $i = 1; $i <= scalar @header; $i++ ) {
	      if( $header[$i-1] eq 'ID' ) {
		if ( defined $self -> {'idcolumn'} and not $i == $self -> {'idcolumn'} ) {
		  debug -> warn( level   => 1,
				 message => "The supplied columns for the ID data item (".
				 $self -> {'idcolumn'}.") does not match the column where the CONT ".
				 "header was found ($i), using $i" );
		}
		$self -> {'idcolumn'} = $i;
	      }
	    }
	  }
	}

# I'm not certain on how to deal with this conflict. I'm leaving it commented because I believe this code should not be here.
#
#<<<<<<< data_subs.pm
#	$header[0] =~ s/$ignoresign//
#	  if ( defined $self->ignoresign );
#	shift( @header ) if ( $header[0] eq "" );
#=======
#>>>>>>> 1.28

# It is ok with data sets without a header.
#	unless( scalar @header > 0 ){ debug -> die( message => 'Datafile ' . $self -> full_name . ' is empty.' ); }

	$self -> {'header'} = \@header;
	$self -> {'comment'} = \@data;
# 	if ( $PsN::config -> {'_'} -> {'use_database'} and
# 	     $self -> {'use_data_table'} ) {
# 	  my $dbh = DBI -> connect("DBI:mysql:host=".$PsN::config -> {'_'} -> {'database_server'}.
# 			       ";databse=".$PsN::config -> {'_'} -> {'project'},
# 				   $PsN::config -> {'_'} -> {'user'},
# 			        $PsN::config -> {'_'} -> {'password'},
# 				   {'RaiseError' => 1});
# 	  if ( scalar @header < 1 ) {
# 	    for ( my $i = 1; $i <= $columns; $i++ ) {
# 	      push( @header, $i );
# 	    }
# 	  }
# 	  for ( my $i = 0; $i <= $#header; $i++ ) {
# 	    my $sth = $dbh -> prepare("INSERT INTO ".$PsN::config -> {'_'} -> {'project'}.
# 			       ".data_column ".
# 				      "(name,number,data_id) ".
# 				      "VALUES ('".$header[$i]."', '".($i+1).
# 				      "', '".$self -> {'data_id'}."' )");
# 	    $sth -> execute;
# 	    push( @{$self -> {'data_column_ids'}}, $sth->{'mysql_insertid'} );
# 	    $sth -> finish;
# 	  }
# 	  $dbh -> disconnect;
# 	}
      }
end _read_header

# }}} _read_header

# {{{ _read_individuals

start _read_individuals
      {
	my $idcol	 = $self -> idcolumn;
	my $filename	 = $self -> full_name;
	#debug -> warn( level   => 1,
	#	       message => "Building array of individuals from file " . $self -> {'filename'} );
	open(DATAFILE,"$filename") || 
	  die "Could not open $filename for reading";
        my ( @new_row, $new_ID, $old_ID, @init_data );
	my $buffer;
	my $lines = 0;
	while (sysread DATAFILE, $buffer, 4096) {
	  $lines += ($buffer =~ tr/\n//);
	}
	seek( DATAFILE, 0,0 );

	# For status bar:
	my $status_bar = status_bar -> new( steps => $lines );
					    
	ui -> print( category => 'scm',
		     message  => "Reading data file: ".$self -> filename );
	ui -> print( category => 'scm',
		     message => $status_bar -> print_step(),
		     newline => 0);
	
	my ( $sth, $dbh, $first_row_id, $first_value_id );
	my $insert = 1;

	my $insert_rows;
	my $insert_values;
	my $row_counter = 0;
#	my $individual_counter = 0;
	my $table_counter = 0;
	my $full_row;
      ROW: while ( <DATAFILE> ) {
	  #scan to first table to read. Will do next ROW until table header $skip_tables+1
	  if (($skip_tables>0) && ($table_counter<= $skip_tables)){
	      #if want to read only part of file and have not found start place yet
	      if ( /^TABLE / ) {
		  $table_counter++;
	      }
	      next ROW;
	  }
	  
          s/^ *//;
	  s/\s*\,\s*/\,/g;
          my @new_row	= split(/\,\s*|\s+/);
	  # This regexp check is not time consuming.
          if ( /^\s*\d+|^\s*\./ ) {
	    if ( defined $self -> {'cont_column'} ) {
	      if ( $new_row[$self -> {'cont_column'} - 1] == 1 ) {
		if ( not $self -> {'table_file'} ) { # Skip the CONT=1 rows if this is a table file
		  for ( my $i = $#new_row; $i > 0; $i-- ) {
		    if ( $i != ($self -> {'cont_column'} - 1) ) {
		      unshift( @{$full_row}, $new_row[$i] );
		    }
		  }
		}
		next ROW;
	      } else {
		for ( my $i = $#new_row; $i >= 0; $i-- ) {
#		  if ( $i != ($self -> {'cont_column'} - 1) or $self -> {'table_file'} ) {
		  if ( $i != ($self -> {'cont_column'} - 1) ) {
		    unshift( @{$full_row}, $new_row[$i] );
		  }
		}
	      }
	    } else {
	      @{$full_row} = @new_row;
	    }
            $new_ID = $full_row -> [$idcol-1]; # index starts at 0
            $old_ID = $new_ID if ( not defined $old_ID );

	    #If we have not yet found first individual to read, then
	    #count each time new individual found. If new individual is 
	    #first individual to read, then reset old_ID so that 
	    #the individual's lines will be read before new individual is pushed.
	    #If we have not found first individual to read then skip to next line in file
	    #if ($skip_individuals > $individual_counter) {
		##can only enter here if skip_individuals > 0 and have not started reading
		#if ( $new_ID != $old_ID ) {
		#    $individual_counter++;
		#}
		#$old_ID = $new_ID;
		#unless ($skip_individuals == $individual_counter) {
		#    #discard what has been read and skip to next line
		#    $full_row = undef; 
		#    next ROW;
		#}
	    #} 


	    # Check if column miss data at some row (This adds about 30% of init time)
	    my $mdt = $self -> {'missing_data_token'};
	    for( my $i = 0; $i <= $#{$full_row}; $i++ ){
		$self -> {'have_missing_data'} -> {$i+1} = 1
		  if( $full_row -> [$i] == $mdt ); # == is slower but safer than eq
	    }

            if ( $new_ID != $old_ID ) {
	      my @subject_data = @init_data;
	      my $id = data::individual -> new ( idcolumn     => $idcol,
						 subject_data => \@subject_data,
						 data_id      => $self -> {'data_id'} );
	      push( @{$self -> {'individuals'}}, $id );
	      #check if have stored max number individuals
	      if ($max_individuals > 0) {
		  if (scalar(@{$self -> {'individuals'}}) == $max_individuals){
		      @init_data =(); #prevent any more rows from being stored after loop
		      last ROW;
		  }
	      }

	      @init_data =(join( ",", @{$full_row}));
            } else {
	      push( @init_data, join( ",", @{$full_row}) );
	    }
	    $old_ID = $new_ID;
	    $full_row = undef;
          }
	  if ( $status_bar -> tick() ) {
	    ui -> print( category => 'scm',
			 message  => $status_bar -> print_step(),
			 wrap     => 0,
			 newline  => 0 );
	  }
        }

	# if we have ended loop because of max number individuals, init_data will be empty.
	if ( $#init_data >= 0 ) {
	  push( @{$self -> {'individuals'}},
		data::individual -> new ( idcolumn     => $idcol,
					  subject_data => \@init_data ) );
	}
	ui -> print( category => 'scm',
		     message  => " ... done" );
	close(DATAFILE);
#	$self -> _write( filename => 'test.dta' );
      }
end _read_individuals

# }}} _read_individuals

# {{{ create_row_filter

start create_row_filter
{
    unless ($self -> {'synced'}){
	'debug' -> die(message => "Cannot use this function with non-synced data.");
    }

    my %index_hash=();
    my $index=0;
    my $keep;
    my $ind_counter=0;

    my $count=scalar(@{$self -> {'individuals'}});
    if ($no_individuals < 1){
	'debug' -> die(message =>"Requested filter length must be at least 1 individual.");
    }
    if ($no_individuals > $count){
	'debug' -> die(message =>"Requested filter length $no_individuals individuals is larger ".
		       "than number of individuals in loaded dataset $count.");
    }
    

#  if ( not $column =~ /^\d/ ) {
#    $column = $self -> {'column_head_indices'} -> {$column} - 1;
#  }

    foreach my $column_name (@{$self -> {'header'}}){
	#could add if-statement here to allow different filter types.
	if ($column_name =~ /^(MDV)$/){
	    if (exists $index_hash{$1}){
		'debug' -> die(message =>"Found column header $1 twice, bailing out.");
	    }
	    $index_hash{$1}=$index;
	}
	$index++;
    }

    #if no columns to filter on were found, return empty filter array 
    #which means "keep everything". Otherwise enter loop below.

    unless (scalar(keys %index_hash) < 1){
	foreach my $individual ( @{$self -> {'individuals'}} ) {
	    foreach my $datarow ( @{$individual -> {'subject_data'}}){
		$keep = 1;
		my @row = split( /,/ , $datarow );
		foreach my $key (keys %index_hash){
		    if ($row[$index_hash{$key}] != 0){
			$keep = 0;
			last;
		    }
		}
		push (@filter,$keep);
	    }
	    $ind_counter++;
	    if ($ind_counter == $no_individuals){
		last;
	    }
	}
    }

}
end create_row_filter

# }}} create_row_filter

# {{{ append_columns_to_matrix

start append_columns_to_matrix
{
    my $row_count = scalar(@{$matrix}); #avreferera
    my ($column_count,$offset);

    if ($row_count < 1){
	'debug' -> die(message => "Matrix cannot be empty in append_columns_to matrix.");
    }
    if (scalar(@columns)<1){
	'debug' -> die(message => "Column array cannot be empty in append_columns_to matrix.");
    }
    if (scalar(@columns)%$row_count > 0){
	'debug' -> die(message => "Column element count must be multiple of row count in matrix.");
    }

    $column_count = scalar(@columns)/$row_count;

    for (my $i=0; $i<$column_count; $i++){
	$offset=$i*$row_count;
	for (my $j=0; $j<$row_count; $j++){
	    ${$matrix}[$j] .= ','. $columns[$offset+$j];
	}
    }
}
end append_columns_to_matrix

# }}} append_columns_to_matrix


